PARAMETERS user_num;

SET OPTION public.Global_Database_ID = {user_num};
SET permanent;

GRANT CONNECT TO "cons" IDENTIFIED BY sql;
GRANT GROUP TO "cons";
GRANT RESOURCE, DBA, REMOTE DBA TO "cons";
GRANT CONSOLIDATE TO "cons" TYPE "FILE" ADDRESS 'cons';

GRANT CONNECT TO "rem{user_num}" IDENTIFIED BY sql;
GRANT REMOTE DBA TO "rem{user_num}";
GRANT PUBLISH TO "rem{user_num}";
GRANT MEMBERSHIP IN GROUP "cons" TO "rem{user_num}";
CREATE REMOTE MESSAGE TYPE FILE ADDRESS 'rem{user_num}';

CONNECT USER cons IDENTIFIED BY sql;

CREATE TABLE admin (
        a_pkey                        bigint NOT NULL DEFAULT GLOBAL AUTOINCREMENT(1000000),
        textcol                       char(64) NULL,
        PRIMARY KEY (a_pkey)
);

CREATE TABLE parent (
        p_pkey                        bigint NOT NULL DEFAULT GLOBAL AUTOINCREMENT(1000000),
        rep_id                        integer NOT NULL,
        textcol                       char(64) NULL,
        PRIMARY KEY (p_pkey)
);

CREATE TABLE child (
        c_pkey                        bigint NOT NULL DEFAULT GLOBAL AUTOINCREMENT(1000000),
        p_pkey                        bigint NOT NULL,
        textcol                       char(64) NULL,
        PRIMARY KEY (c_pkey)
);

ALTER TABLE child ADD NOT NULL FOREIGN KEY (p_pkey) REFERENCES parent (p_pkey);

CREATE PUBLICATION p1 (
        TABLE cons.admin,
        TABLE cons.parent,
        TABLE cons.child
);

CREATE SUBSCRIPTION TO p1 FOR "cons";
START SUBSCRIPTION TO p1 FOR "cons";

create procedure cons.rep_data(in iter integer default 1,in do_commit integer default 0)
begin
  declare loop_var integer;
  declare par_value bigint;
  set loop_var=0;
  while loop_var < iter loop
    insert into cons.admin values( default,uuidtostr(newid()) ) ;
    insert into cons.parent values( default,{user_num},uuidtostr(newid()) ) ;
    set par_value=@@identity;
    insert into cons.child values( default,par_value,uuidtostr(newid()) ) ;
    insert into cons.child values( default,par_value,uuidtostr(newid()) ) ;
    insert into cons.child values( default,par_value,uuidtostr(newid()) ) ;
    set loop_var=loop_var+1;
    if do_commit = 1 then
      commit work
    end if
  end loop
end
go

call rep_data( 10 );
commit;
